unit UDatabase;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, USqlDatabase;

type
  TDatabase = class;

  { TDbObject }

  TDbObject = class
    Id: Integer;
    Loaded: Boolean;
    Database: TDatabase;
    procedure Store; virtual;
    procedure Load; virtual;
    procedure Delete;
    constructor Create;
    destructor Destroy; override;
  end;

  TDbObjectClass = class of TDbObject;

  { TDbList }

  TDbList = class
    Id: Integer;
    Database: TDatabase;
    ItemClassType: TDbObjectClass;
    Items: TList;
    constructor Create;
    destructor Destroy; override;
    function Add: TDbObject;
    procedure Store;
    procedure Load;
  end;

  { TDbResultSet }

  TDbResultSet = class
    Items: TList;
    procedure Delete;
  end;

  { TDatabase }

  TDatabase = class(TSqlDatabase)
    BaseObject: TDbObject;
    constructor Create;
    destructor Destroy; override;
    procedure Init;
  end;

implementation

procedure TDbObject.Store;
begin

end;

procedure TDbObject.Load;
begin

end;

procedure TDbObject.Delete;
begin

end;

constructor TDbObject.Create;
begin
end;

destructor TDbObject.Destroy;
begin
  inherited Destroy;
end;

{ TDbList }

constructor TDbList.Create;
begin
  Items := TList.Create;
end;

destructor TDbList.Destroy;
var
  I: Integer;
begin
  for I := 0 to Items.Count - 1 do
    TDbObject(Items[I]).Free;
  Items.Free;
  inherited Destroy;
end;

function TDbList.Add: TDbObject;
var
  Data: TAssocArray;
begin
  Result := ItemClassType.Create;
  Data := TAssocArray.Create;
  Data.AddKeyValue('id', '');
  Database.Insert(ClassName, Data);
  Result.Id := Database.LastInsertId;;
  Items.Add(Result);
end;

procedure TDbList.Store;
var
  I: Integer;
  Data: TAssocArray;
begin
  Data := TAssocArray.Create;
  Database.Insert(ClassName, Data);
  for I := 0 to Items.Count - 1 do begin
    Database.Insert(ClassName, Data);
  end;
end;

procedure TDbList.Load;
begin

end;

{ TDbResultSet }

procedure TDbResultSet.Delete;
var
  I: Integer;
begin
  for I := 0 to Items.Count - 1 do
    TDbObject(Items[I]).Free;
  Items.Free;
end;

{ TDatabase }

constructor TDatabase.Create;
begin
  BaseObject := TDbObject.Create;;
end;

destructor TDatabase.Destroy;
begin
  BaseObject.Free;
end;

procedure TDatabase.Init;
begin
  BaseObject.Id := 1;
  BaseObject.Database := Self;
  BaseObject.Load;
end;

end.

